leetcode 2749. 得到整数零需要执行的最少操作数 中等

给你两个整数:num1 和 num2 。

在一步操作中,你需要从范围 [0, 60] 中选出一个整数 i ,并从 num1 减去 2^i + num2 。

请你计算,要想使 num1 等于 0 需要执行的最少操作数,并以整数形式返回。

如果无法使 num1 等于 0 ,返回 -1 。

示例 1:

复制代码
输入:num1 = 3, num2 = -2
输出:3
解释:可以执行下述步骤使 3 等于 0 :
- 选择 i = 2 ,并从 3 减去 22 + (-2) ,num1 = 3 - (4 + (-2)) = 1 。
- 选择 i = 2 ,并从 1 减去 22 + (-2) ,num1 = 1 - (4 + (-2)) = -1 。
- 选择 i = 0 ,并从 -1 减去 20 + (-2) ,num1 = (-1) - (1 + (-2)) = 0 。
可以证明 3 是需要执行的最少操作数。

示例 2:

复制代码
输入:num1 = 5, num2 = 7
输出:-1
解释:可以证明,执行操作无法使 5 等于 0 。

提示:

  • 1 <= num1 <= 10^9
  • -10^9 <= num2 <= 10^9

分析:从 1 开始,枚举操作次数 k 的值,对于每 k 次操作,可以看做 num1 先减去 k 个 num2,再判断这个值能否由 k 个 2 的幂组成。不妨令 x = num1 - k * num2,假设操作次数为 k 时得到 x ,它的二进制表示下有 f(x) 个 1,如果 k 符合题意,需要满足下面的条件:

1、k <= x,这是 k 的上限,当 k 大于 x 时,无论如何不可能凑出 k 个 2 的幂之和等于 x。

2、k >= f(x),至少需要 f(x) 个 2 的幂之和,才能通过求和凑出 x,k 可以大于 f(x),因为 2^i=2^(i-1)*2

上面 2 条就是枚举的终止条件。接下来继续观察 x,当 k=0 时,x>k,且 x 随着 k 的增加而单调递减。因此在增加 k 时,如果出现了 x<k 的情况,随着 k 继续增大,x<k 始终满足。因此在第一次出现 x<k 时,我们就可以判定此题无解,提前返回 −1。

cpp 复制代码
int makeTheIntegerZero(int num1, int num2) {
    int k = 1;
    while (1) {
        long long x = (long long)num1 - (long long)num2 * k;
        if (x < k) {
            return -1;
        }
        if (k >= __builtin_popcountll(x)) {
            return k;
        }
        k++;
    }
}
相关推荐
文丑颜不良啊21 小时前
LeetCode1661~1680题目解析
java·leetcode
文丑颜不良啊1 天前
LeetCode1721~1740题目解析
java·leetcode
文丑颜不良啊1 天前
LeetCode1681~1700题目解析
java·leetcode
开开心心就好1 天前
网页图片批量下载工具,输入链接就保存
服务器·算法·leetcode·支持向量机·pdf·ocr·1024程序员节
圣保罗的大教堂1 天前
leetcode 462. 最小操作次数使数组元素相等 II 中等
leetcode
Navigator_Z1 天前
LeetCode //C - 1313. Decompress Run-Length Encoded List
c语言·算法·leetcode
Nuanyt1 天前
LeetCode Hot 100 链表专题(四)· 3 题(Java)
java·算法·leetcode·链表·双指针
圣保罗的大教堂2 天前
leetcode 453. 最小操作次数使数组元素相等 中等
leetcode
Tisfy2 天前
LeetCode 0453.最小操作次数使数组元素相等:两次遍历(反向思维)
算法·leetcode·题解·遍历·反向思维
君万2 天前
【LeetCode每日一题】回溯:46. 全排列 78. 子集 39. 组合总和
算法·leetcode·go